class ClockView extends javax.swing.JFrame {

    private javax.swing.JLabel tLabel = new javax.swing.JLabel();

    ClockView() {   // constructor
        this.setDefaultCloseOperation(
              javax.swing.WindowConstants.EXIT_ON_CLOSE);
        this.setSize(95,45);
        this.getContentPane().add(tLabel);
        this.refreshTimeDisplay();
    }

    protected String getDigitsAsString(int i) {
        String str = Integer.toString(i);
        if (i<10) str = "0"+str;
        return str;
    }

    public void refreshTimeDisplay() {
        Timestamp t = new Timestamp();
        t.fillTimes();
        String display = getDigitsAsString(t.hrs) + ":"
                     + getDigitsAsString(t.mins)  + ":"
                     + getDigitsAsString(t.secs);
        tLabel.setText("  " + display );
        tLabel.repaint();
    }

}
