class Animal {   }

class Chordata extends Animal { final boolean spine=true; }

// All mammals have a spinal cord. They inherit it as a characteristic 
// because they are a subclass of the chordata phylum (fancy words 
// for "the group with spines"). 

// Mammals, such as humans, also have specialized characteristics: 
// they feed their young milk, they have hair, they have two generations of teeth, and so on. 

class Mammal extends Chordata { final int teeth_gens = 2; }


// Primates inherit all the characteristics of mammals, 
// including the quality of having a spinal cord, which 
// mammals inherited from their parent type. 

// The primate subclass is specialized with forward facing eyes,
// a large braincase, and so on to increasingly specialized subtypes.

class Primate extends Mammal { final String braincaseSize = "large"; }
