// Comparable interface using generics
// compile with "javac -source 1.5 example3.java"

class MyInt implements Comparable <MyInt> {
    private int mi;
    public MyInt(int i) { mi = i; }      // constructor
    public int getMyInt() { return mi; } // getter

    public int compareTo(MyInt other) {
        return (this.mi - other.mi);  // NEW - no cast from Obj
    }

} 


public class example3 {

    public static void main(String[] args) {
        MyInt m4 = new MyInt(4);
        MyInt m5 = new MyInt(5);

        int result = m4.compareTo(m5);  // negative, zero or positive

        System.out.println("4 compared to 5 has result of "+result);
    }

}

