//   Expand a .gz file into uncompressed form 
//   Peter van der Linden 

import java.io.*;  
import java.util.zip.*; 
public class expandgz { 

      public static void main (String args[]) throws Exception { 
               if (args.length == 0) { 
                       System.out.println("usage:  java expandgz  filename.gz"); 
                       System.exit(0); 
               } 
               GZIPInputStream gzi = new GZIPInputStream( 
                                               new FileInputStream( args[0] )); 
              int to = args[0].lastIndexOf('.'); 
              if (to == -1) { 
                       System.out.println("usage:  java expandgz  filename.gz"); 
                       System.exit(0); 
               } 
               String fout = args[0].substring(0, to);  
               BufferedOutputStream bos = new BufferedOutputStream( 
                                                 new FileOutputStream(fout) ); 
               System.out.println("writing " + fout); 

               int b; 
                do { 
                       b = gzi.read(); 
                       if (b==-1) break; 
                       bos.write(b); 
               } while (true); 
               gzi.close(); 
               bos.close(); 
       } 
}
