import java.io.*;
import java.nio.*; 
import java.nio.channels.*; 
public class Buffer2 { 
    public static void main(String[] a) throws Exception { 
        // Get a Channel for the file 
        FileInputStream fis = 
                       new FileInputStream("numbers.bin"); 
        FileChannel fc = fis.getChannel(); 
        ByteBuffer bb = java.nio.ByteBuffer.allocate(400); 
        // fill the buffer from the file 
        int count = fc.read(bb); 

        bb.rewind(); // need to move buffer index back to start 
        IntBuffer ib = bb.asIntBuffer(); 
        // bulk get into an int array 
        int[] myIntArray = new int[50]; 
        ib.get( myIntArray ); 
        for (int i=0; i<5; i++) { 
           System.out.println( "arr["+i+"]="+ myIntArray[i] ); 
        } 
        fc.close(); 
    } 
} 
