
/* the basis for a screen capture program.
 * it just dumps it out in grab.jpg and grab.gif
 */

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.io.*;
import javax.imageio.*;

public class snap {
	public static void main(String[] args) throws Exception {
           // grab the entire screen
                Robot ro = new Robot();
                Toolkit t = Toolkit.getDefaultToolkit();
                final Dimension d = t.getScreenSize();
                Rectangle re = new Rectangle(d.width, d.height);
		final Image image = ro.createScreenCapture( re );

                String fname = "dump";
                if (args.length > 0)  fname = args[0];
       
              try {
                BufferedImage bi = null;
                if (image instanceof BufferedImage) {
                    bi = (BufferedImage) image;
                } else {
                    System.out.println("Sorry, not a buffered image");
                    System.exit(0);
                }
                // Graphics2D big = bi.createGraphics();
                // big.setPaint(Color.red);
                // big.drawString ("Date: Oct 2001 ABCDEFGHIJKLMNOPQRSTUVWXYZ", 20, 20);
                File f = new File(fname + ".gif");
                ImageIO.write(bi, "gif", f);

                f = new File(fname + ".jpg");
                ImageIO.write(bi, "jpg", f);

                f = new File(fname+".png");
                ImageIO.write(bi, "png", f);
                System.out.println("Have finished writing to dump.gif, jpg, png ");

              } catch (Exception e) { System.out.println("Excpn: "+e);}
	}

}

