// compile with:   javac -source 1.5  example.java
//     run with:   java example

public class example {

    public static void main(String[] args) {

        int i = 15;
        Integer myInt = new Integer(i); //wrap an int in a object
    
        // get the printable representation of an Integer:
        String s = myInt.toString();
    
        // gets the Integer as a printable hex string
        String s2 = myInt.toHexString(15); // s is now 0x0f
    
        // reads a string, and gives you back an int
        i = myInt.parseInt( "2047" );
    
        // reads a string, and gives you back an Integer object
        myInt = myInt.valueOf( "2047" );

      /////// autoboxing
        int i2 = 27;
        Integer myInt2 = i2;          //  autobox!

        Double dObj = 27.0;  // autobox
        double d = dObj;     // unbox, gets value 27.0

        Float fObj1 = 20.0F;  // boxing
        Float fObj2 = 10.0F;  // boxing
        float result = fObj1 * fObj2;  // unboxing 
        Float fObj3 = fObj1 * 23.0F;   // boxing and unboxing

      ///////////
        String s3 = "ABCD".toLowerCase();
        System.out.println("string is: " + s3);

        String s4 = 	 "Thomas the Tank Engine and the naughty " 
	+ "Engine-driver who tied down Thomass Boiler Safety Valve"
	+ "and How They Found Pieces of Thomas in Three Counties." 
    }

}
