import java.io.*; 
import java.util.*;
import java.sql.Timestamp;
public class Dump { 

    static FileInputStream myFIS = null; 
    static FileOutputStream myFOS = null; 
    static PrintStream myPOS = null; 

    static public void main(String[] arg) { 
           PrintStream e = System.err; 
           try { 
               myPOS = new PrintStream ( arg[0]+".hex" );
               long now = new Date().getTime();
               myPOS.printf("Hex dump of file %s %s %n", arg[0], new Timestamp(now)); 
               myFIS = new FileInputStream(arg[0]); 
                  
               while ( myFIS.available()>0 ) 
                        dump( (byte)myFIS.read() ); 
           } catch(IOException x) { 
                      e.println("Exception: " + x.getMessage() ); 
           } 
    } 

    static private long byteCount = 0; 

//  %[argument_index$][flags][width][.precision]conversion
//  %                   0       8               x
//                      zero padded
//  Looks like Sun has dropped the "^" flag meaning "to upper case".

    static private void dump(byte b) { 
           if (byteCount % 16 == 0)  
                 myPOS.printf("%n%08x:", byteCount);
           // output a space every 4 bytes 
          if (byteCount++ % 4 == 0)  
                 myPOS.print("  "); 

           // dump the byte as 2 hex chars 
           myPOS.printf("%02x", b);
    } 
} 
