//   Convert a big number into binary and write it out 
//   Peter van der Linden, June 2001 

import java.io.*; 
import java.math.*; 
public class togz { 

       static String illegalPrime = 
"4856507896573978293098418946942861377074420873513579240196520736" + 
"plug the rest of the number in here... " ; 

       static BigInteger b = new BigInteger(illegalPrime); 
       static final BigInteger two_five_six = new BigInteger("256"); 

       static byte[] result = new byte[illegalPrime.length()]; 

       public static void main (String args[]) throws Exception { 
                BigInteger d_r []; 

                if (b.isProbablePrime(3))  
                           System.out.println("b is probably prime (good)"); 
                else System.out.println("b is probably not prime (bad!)"); 

                int i=0; 
                do { 
                           d_r = b.divideAndRemainder(two_five_six); 
                           b = d_r[0];     // the multiple 
                           result[i++] = (byte) d_r[1].intValue();  // the remainder 
                } while ( b.compareTo( two_five_six ) >= 0); 

                result[i] = (byte) b.intValue(); 

                System.out.println("writing bytes.gz"); 
                FileOutputStream fos = new FileOutputStream("bytes.gz"); 

                DataOutputStream dos = new DataOutputStream(fos); 
                for (int j=i; j>0; j--) { 
                           dos.writeByte( result[j] ); 
          } 
                fos.close(); 
       } 
}
