import java.io.*; 
import java.nio.channels.*; 
public class Lock { 
    public static void main(String[] a) throws Exception { 
       // Get a Channel for the file 
       FileOutputStream fos = new FileOutputStream("data.txt"); 
       FileChannel fc = fos.getChannel(); 
       while (true) { 
           // Try to get a lock 
           FileLock lock = fc.tryLock(); 
           if (lock !=null) { 
               System.out.println("got lock"); 
               Thread.sleep(2000);   // simulate some work 
               System.out.println("about to release lock"); 
               lock.release(); 
           } 
           Thread.sleep(333); 
       } 
    } 
} 
