import java.util.regex.*; 
import java.io.*; 
import java.nio.*; 
import java.nio.charset.*; 
import java.nio.channels.*; 

public class Extract { 

    public static void main(String[] args) throws Exception { 
        // Create a pattern to match comments 
        Pattern p = Pattern.compile("To: bbb@sun.com"); 

        // Get a Channel for the source file 
        FileInputStream fis = new FileInputStream("email.txt"); 
        FileChannel fc = fis.getChannel(); 

        // Map a Buffer in from the data file, and decode the bytes
        MappedByteBuffer bb =  
           fc.map(FileChannel.MapMode.READ_ONLY, 0,(int)fc.size()); 
        Charset cs = Charset.forName("8859_1"); 
        CharsetDecoder cd = cs.newDecoder(); 
        CharBuffer cb = cd.decode(bb); 

        // Run some matches 
        Matcher m = p.matcher(cb); 
        while (m.find()) 
            System.out.println("Found text: "+m.group()); 
    } 

}
